//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3F6F19F00040.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3F6F19F00040.cm

//## begin module%3F6F19F00040.cp preserve=no
//## end module%3F6F19F00040.cp

//## Module: MixBase%3F6F19F00040; Package specification
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/MixBase.h

#ifndef MIXBASE_H
#define MIXBASE_H 1

//## begin module%3F6F19F00040.additionalIncludes preserve=no
//## end module%3F6F19F00040.additionalIncludes

//## begin module%3F6F19F00040.includes preserve=yes
//## end module%3F6F19F00040.includes

// xsTypes
#include "xsTypes.h"
// Error
#include <XSUtil/Error/Error.h>
//## begin module%3F6F19F00040.declarations preserve=no
//## end module%3F6F19F00040.declarations

//## begin module%3F6F19F00040.additionalDeclarations preserve=yes
//## end module%3F6F19F00040.additionalDeclarations


//## begin MixBase%3F6F19B9013F.preface preserve=yes
//## end MixBase%3F6F19B9013F.preface

//## Class: MixBase%3F6F19B9013F
//	Base class for mixing model implementations.
//
//	Invoking mixing models will be done in Model::calculate.
//
//	This will call Model::mix(SumComponent&)
//
//	which will transform the model according to the mixing
//	model's prescription.
//
//	The interface for mixing models (initially) consists of
//	an initializing function and a run (perform) function
//	which are both abstract.
//## Category: XSModel::Model::Component%3666B89A8340
//## Subsystem: XSModel::Model::Component%367691A33718
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3F940F730077;GroupFluxContainer { -> }

class MixBase 
{
  //## begin MixBase%3F6F19B9013F.initialDeclarations preserve=yes
  //## end MixBase%3F6F19B9013F.initialDeclarations

  public:
    //## Class: IncompatibleData%3F6F1F4A0343
    //	Throw when loaded data doesn't contain information
    //	needed to compute a mixing model.
    //## Category: XSModel::Model::Component%3666B89A8340
    //## Subsystem: XSModel::Model::Component%367691A33718
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class IncompatibleData : public YellowAlert  //## Inherits: <unnamed>%3F9EE3E503B3
    {
      public:
        //## Constructors (specified)
          //## Operation: IncompatibleData%3F9EE4B600AB
          IncompatibleData (const string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Class: NoDataPresent%3F9EE371037C
    //## Category: XSModel::Model::Component%3666B89A8340
    //## Subsystem: XSModel::Model::Component%367691A33718
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class NoDataPresent : public YellowAlert  //## Inherits: <unnamed>%3F9EE3E90321
    {
      public:
        //## Constructors (specified)
          //## Operation: NoDataPresent%3F9EE5CB0136
          NoDataPresent (const string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Class: DataOrderingError%3F9EE40F036E
    //## Category: XSModel::Model::Component%3666B89A8340
    //## Subsystem: XSModel::Model::Component%367691A33718
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class DataOrderingError : public YellowAlert  //## Inherits: <unnamed>%3F9EE4270207
    {
      public:
        //## Constructors (specified)
          //## Operation: DataOrderingError%3F9EE42E028F
          DataOrderingError (const string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Destructor (generated)
      virtual ~MixBase() = 0;


    //## Other Operations (specified)
      //## Operation: initialize%3F6F1BB802AE
      virtual void initialize (const std::vector<Real>& params, const std::string& modelName = std::string(""));

      //## Operation: perform%3F6F1BC1032B
      virtual void perform (const EnergyPointer& energy, const std::vector<Real>& params, GroupFluxContainer& flux, GroupFluxContainer& fluxError) = 0;

      //## Operation: verifyData%3F8EDA24029B
      virtual void verifyData () const;

      //## Operation: initializeForFit%3F97E8CE000C
      virtual void initializeForFit (const std::vector<Real>& params, bool paramsAreFrozen);

      //## Operation: refreshTransform%3FAFDA2B0141
      virtual void refreshTransform ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: name%405B19120080
      const string& name () const;

  public:
    // Additional Public Declarations
      //## begin MixBase%3F6F19B9013F.public preserve=yes
      //## end MixBase%3F6F19B9013F.public

  protected:
    //## Constructors (specified)
      //## Operation: MixBase%405B19F600A4
      MixBase (const string& name);

    // Additional Protected Declarations
      //## begin MixBase%3F6F19B9013F.protected preserve=yes
      //## end MixBase%3F6F19B9013F.protected

  private:
    //## Assignment Operation (generated)
      MixBase & operator=(const MixBase &right);

    // Additional Private Declarations
      //## begin MixBase%3F6F19B9013F.private preserve=yes
      //## end MixBase%3F6F19B9013F.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin MixBase::name%405B19120080.attr preserve=no  public: const string {U} 
      const string m_name;
      //## end MixBase::name%405B19120080.attr

    // Additional Implementation Declarations
      //## begin MixBase%3F6F19B9013F.implementation preserve=yes
      //## end MixBase%3F6F19B9013F.implementation

};

//## begin MixBase%3F6F19B9013F.postscript preserve=yes
//## end MixBase%3F6F19B9013F.postscript

// Class MixBase::IncompatibleData 

// Class MixBase::NoDataPresent 

// Class MixBase::DataOrderingError 

// Class MixBase 

//## Get and Set Operations for Class Attributes (inline)

inline const string& MixBase::name () const
{
  //## begin MixBase::name%405B19120080.get preserve=no
  return m_name;
  //## end MixBase::name%405B19120080.get
}

//## begin module%3F6F19F00040.epilog preserve=yes
//## end module%3F6F19F00040.epilog


#endif
